package ru.upworld.chat;

import org.bukkit.Bukkit;
import org.bukkit.ChatColor;
import org.bukkit.entity.Player;
import org.bukkit.event.EventHandler;
import org.bukkit.event.Listener;
import org.bukkit.event.player.AsyncPlayerChatEvent;

public class ChatListener implements Listener {

    private static final String formatLocal = "%chatPrefix" + ChatColor.GREEN + "%player: " + ChatColor.WHITE + "%message";
    private static final String formatGlobl = ChatColor.BOLD + "%chatPrefix" + ChatColor.GOLD + "%player: " + ChatColor.BLUE + "%message";

    @EventHandler
    public void AsyncPlayerChatEvent(AsyncPlayerChatEvent e) {
        String message = e.getMessage();
        Player player = e.getPlayer();
        String formated = ChatUtil.translateColorCodes(formatLocal);
        Chat chat = message.startsWith("!") ? Chat.GLOBAL : Chat.LOCAL;

        if (chat == Chat.LOCAL) {
            e.getRecipients().clear();
            Bukkit.getOnlinePlayers().stream().filter((p) -> (p.getLocation().distance(player.getLocation()) <= 100)).forEachOrdered((p) -> {
                e.getRecipients().add(p);
            });
        } else {
            e.setMessage(message.replaceFirst("!", ""));
            formated = ChatUtil.translateColorCodes(formatGlobl);
            
        }
        formated = formated.replace("%chatPrefix", chat.getPrefix());
        formated = formated.replace("%message", "%2$s").replace("%player", "%1$s");
        System.out.println(formated);
        e.setFormat(formated);
    }

    public enum Chat {
        GLOBAL("§9[§4Кричит§9]§f "), LOCAL("");

        private final String prefix;

        public String getPrefix() {
            return prefix;
        }

        private Chat(String prefix) {
            this.prefix = prefix;
        }
    }
}
