package ru.upworld.chat;

import org.bukkit.Bukkit;
import org.bukkit.ChatColor;
import org.bukkit.command.Command;
import org.bukkit.command.CommandExecutor;
import org.bukkit.command.CommandSender;
import org.bukkit.entity.Player;

public class CommandMsg implements CommandExecutor {

    private final String usage = ChatColor.RED + "/m <имя> <послание>";
    private final String noMessage = ChatColor.RED + "Вы ничего не нашептали";
    private final String playerIsOffline = ChatColor.RED + "Кажется он(а) не с нами.";

    private final String formatPrivateSend = "&e[&8шепчете &f{NAME}&e] ";
    public static final String formatPrivateMe = "&e[&f{NAME} &8шепчет&e] ";

    @Override
    public boolean onCommand(CommandSender sender, Command cmnd, String string, String[] args) {
        if (args.length == 0) {
            sender.sendMessage(usage);
            return true;
        } else if (args.length == 1) {
            sender.sendMessage(noMessage);
            return true;
        }
        Player pl = Bukkit.getPlayer(args[0]);
        if (pl == null) {
            sender.sendMessage(playerIsOffline);
            return true;
        } else {
            sender.sendMessage(ChatUtil.translateColorCodes(formatPrivateSend.replace("{NAME}", args[0])) + joiner(args));
            pl.sendMessage(ChatUtil.translateColorCodes(formatPrivateMe.replace("{NAME}", sender.getName())) + joiner(args));
            UpWorldChat.log(ChatUtil.translateColorCodes(formatPrivateMe.replace("{NAME}", sender.getName())) + joiner(args));
        }
        return true;
    }

    private String joiner(String[] args) {
        String message = "";
        for (int i = 1; i < args.length; ++i) {
            message = message + args[i] + " ";
        }
        return message;
    }

}
